VERSION 5.00
Object = "{4DE9E2A3-150F-11CF-8FBF-444553540000}#4.0#0"; "DLXOCX32.OCX"
Begin VB.Form Form1 
   Caption         =   "Level Control Panel for DDA-08/16"
   ClientHeight    =   5400
   ClientLeft      =   3165
   ClientTop       =   1800
   ClientWidth     =   5400
   Icon            =   "AOSingle.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5400
   ScaleWidth      =   5400
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   3720
      TabIndex        =   11
      Top             =   4680
      Width           =   1095
   End
   Begin VB.ComboBox cboChannel 
      Height          =   315
      Left            =   2400
      TabIndex        =   7
      TabStop         =   0   'False
      Text            =   "0"
      Top             =   1320
      Width           =   615
   End
   Begin VB.ComboBox cboDevNum 
      Height          =   315
      Left            =   2400
      TabIndex        =   6
      TabStop         =   0   'False
      Text            =   "0"
      Top             =   720
      Width           =   615
   End
   Begin VB.CommandButton cmdInit 
      Caption         =   "Initialize"
      Height          =   375
      Left            =   360
      TabIndex        =   5
      Top             =   720
      Width           =   1815
   End
   Begin DlsrLib.DriverLINXLDD LDD 
      Left            =   4560
      Top             =   840
      _Version        =   262144
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   64
      _Version        =   262144
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   64
   End
   Begin VB.VScrollBar VScroll1 
      Enabled         =   0   'False
      Height          =   3495
      Left            =   3960
      Max             =   -1000
      Min             =   1000
      TabIndex        =   1
      Top             =   600
      Width           =   255
   End
   Begin VB.TextBox Text1 
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "Small Fonts"
         Size            =   6.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   285
      Left            =   2400
      TabIndex        =   0
      Text            =   "0"
      Top             =   2160
      Width           =   735
   End
   Begin DlsrLib.DriverLINXSR dl 
      Left            =   4560
      Top             =   1440
      _Version        =   262144
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   64
   End
   Begin VB.Label Label6 
      Caption         =   "For each Selected Channel, the upper and lower limits will be dynamically determined by use of the DriverLINX LDD object."
      Height          =   615
      Left            =   360
      TabIndex        =   13
      Top             =   3960
      Width           =   3255
   End
   Begin VB.Label Label4 
      Caption         =   $"AOSingle.frx":030A
      Height          =   1095
      Left            =   360
      TabIndex        =   12
      Top             =   2760
      Width           =   3135
   End
   Begin VB.Label Label5 
      AutoSize        =   -1  'True
      BackColor       =   &H000000FF&
      Caption         =   "  KEITHLEY  "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H8000000E&
      Height          =   300
      Left            =   360
      TabIndex        =   10
      Top             =   240
      Width           =   1605
   End
   Begin VB.Label Label2 
      Caption         =   "Device Number: "
      BeginProperty Font 
         Name            =   "Small Fonts"
         Size            =   6.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   135
      Left            =   2400
      TabIndex        =   9
      Top             =   480
      Width           =   1335
   End
   Begin VB.Label Label1 
      Caption         =   "Select Channel : "
      BeginProperty Font 
         Name            =   "Small Fonts"
         Size            =   6.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   840
      TabIndex        =   8
      Top             =   1320
      Width           =   1335
   End
   Begin VB.Label Label3 
      Caption         =   "Value"
      BeginProperty Font 
         Name            =   "Small Fonts"
         Size            =   6.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   135
      Left            =   2400
      TabIndex        =   4
      Top             =   1920
      Width           =   615
   End
   Begin VB.Label lblUpperLimit 
      Caption         =   "10 Volt"
      BeginProperty Font 
         Name            =   "Small Fonts"
         Size            =   6
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   135
      Left            =   3960
      TabIndex        =   3
      Top             =   4200
      Width           =   735
   End
   Begin VB.Label lblLowerLimit 
      Caption         =   "-10 Volt"
      BeginProperty Font 
         Name            =   "Small Fonts"
         Size            =   6
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   135
      Left            =   3960
      TabIndex        =   2
      Top             =   360
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This is a simple example of how to set a plloed mode based, analog
'output operation using DriverLINX. This will output one sample
Option Explicit
Public MaxVolts, MinVolts As Single


Private Sub cboChannel_Click()
    ' if channel has been changed, reassign max and min values
MaxVolts = LDD.AO_MM_max(cboChannel.ListIndex)
MinVolts = LDD.AO_MM_min(cboChannel.ListIndex)
VScroll1.Max = MaxVolts * 100  ' set the scroll bar to these max min values
VScroll1.Min = MinVolts * 100
lblLowerLimit.Caption = Str(MinVolts) & " volts"
lblUpperLimit.Caption = Str(MaxVolts) & " volts"
VScroll1.Value = 0  ' set the scroll bar equal to zero
'VScroll1.SetFocus
End Sub

Private Sub cmdExit_Click()
    ' unload the drivers
    dl.Req_DLL_name = ""
    LDD.Req_DLL_name = ""
    End
End Sub

Private Sub cmdInit_Click()
With dl 'this is the DriverLINX SR control
.Req_op = DL_INITIALIZE 'initialize board
.Req_DLL_name = "kdda816$" 'select the specifc card driver
.Req_device = cboDevNum.ListIndex  ' device number
.Req_subsystem = DL_DEVICE 'select the correct subsystem
.Req_mode = DL_OTHER 'select the correct mode
.Refresh 'start initialize operation
End With 'end this service request

If dl.Res_result = DL_NoErr Then
' use LDD object to get info about the configuration of the DDA board
LDD.Req_DLL_name = dl.Req_DLL_name  ' set LDD equal to same device and driver
LDD.device = dl.Req_device
LDD.Refresh  ' get data about our hardware
Form1.Caption = "Level Control Panel for " & LDD.Dev_Model

    Dim i As Integer
    For i = 0 To LDD.AO_nChan - 1
    cboChannel.AddItem Str(i), i  ' populate channel box
    Next i
    cboChannel.ListIndex = 0  ' set it equal to first entry
    
' assuming we are pointing at channel 0, get the max and min for chan 0
MaxVolts = LDD.AO_MM_max(0)
MinVolts = LDD.AO_MM_min(0)
VScroll1.Max = MaxVolts * 100  ' set the scroll bar to these max min values
VScroll1.Min = MinVolts * 100
lblLowerLimit.Caption = Str(MinVolts) & " volts"
lblUpperLimit.Caption = Str(MaxVolts) & " volts"
VScroll1.Value = 0  ' set the scroll bar equal to zero
VScroll1.Enabled = True
cmdInit.Enabled = False
Form1.SetFocus
Else
showmessage dl 'show any errors
End If

End Sub

Private Sub Form_Load()
Dim i As Integer
    For i = 0 To 5
        cboDevNum.AddItem Str(i), i
    Next i
    cboDevNum.ListIndex = 0 ' set it equal to first entry
End Sub

Sub showmessage(sr As Control) 'showmessage error call
If sr.Res_result <> DL_NoErr Then
sr.Req_op = DL_MESSAGEBOX
sr.Refresh
End If
End Sub



Private Sub VScroll1_Change()

Dim DecPlcs As Double 'dimension the varaible DecPlcs as a double
DecPlcs = 100 'set output to tenths
Text1.Text = VScroll1.Value / DecPlcs 'scale output to tenths

Dim Volt(0) As Single ' Volt is the variable passed to the VBArrayBufferConvert function
Dim dummy As Long

Volt(0) = Val(Text1.Text) 'convert text entry to a value

With dl 'this is the DriverLINX SR control
.Req_subsystem = DL_AO 'use the analog output subsystem
.Req_mode = DL_POLLED 'use polled mode output, Note, interrupt and DMA is unavailable for the KPCI-3102/04 card
.Req_op = DL_START 'operation to begin
.Evt_Str_type = DL_COMMAND 'start on command
.Evt_Stp_type = DL_TCEVENT 'stop when the number of output samples have been sent
.Sel_chan_N = 1 'only using one analog output channel at a time
.Sel_chan_start = cboChannel.ListIndex 'pass the variable for the start channel, you can set propert directly to 0, 1 and etc.
.Sel_chan_stop = cboChannel.ListIndex ' pass the variable for the top channel, you can set propert directly to 0, 1 and etc.
'.Res_Sta_ioValue = dl.DLVolts2Code(Volt) 'pass value to card
.Sel_buf_N = 1
.Sel_buf_samples = 1
End With

' move data from 1 point array to 1 point buffr
dummy = dl.VBArrayBufferConvert(0, 0, 1, Volt, DL_tSINGLE, 0, 0)
'
' for polled mode, single value, you could use the .Res_Sta_ioValue property
' to provide the value to be written on the DAC channel.  This property
' takes counts not volts.  The .DLVolts2Code method can convert single
' values of volts to counts (code), but this method does not fluctuate
' it's calculated value for each gain the board might be operated at.
'
' use of the VBArrayBufferConvert is a more bullet-proof approach as it is
' always range of the channel aware.

dl.Refresh 'start analog output operation


showmessage dl 'show any errors


End Sub

